import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.rmi.RemoteException;
import java.rmi.server.RMIClientSocketFactory;
import java.rmi.server.RMIServerSocketFactory;
import java.rmi.server.UnicastRemoteObject;
import java.security.AccessControlContext;
import java.security.AccessController;
import java.security.PrivilegedActionException;
import java.security.PrivilegedExceptionAction;

import javax.security.auth.Subject;


public class ServiceImpl extends UnicastRemoteObject implements Service{

	Subject subject=null;
	int val=1;
	public ServiceImpl(Subject sub) throws RemoteException {
		super();
		subject=sub;
	}
	public ServiceImpl(Subject sub, int port, RMIClientSocketFactory clientFactory, RMIServerSocketFactory serverFactory) throws RemoteException {
		super(port,clientFactory,serverFactory);
		subject=sub;
	}
	
	@Override
	public int getVal() throws RemoteException {
		return val;
	}
	
	@Override
	public  synchronized int  setVal(final int v, final Facturation cname) throws RemoteException {
		// la mthode est synchronized car interdit que plusieurs clients modifient val en meme temps

		try{
			System.out.println("Qui est le sujet : " + subject + " ");//+ Subject.getSubject(AccessController.getContext()));
			val=(Integer)Subject.doAsPrivileged(subject, 
					new PrivilegedExceptionAction<Object>() {
				public void ecrireFichier(){
					try {
						FileOutputStream fo=new FileOutputStream(new File("essaiResultat"));
						fo.write(new byte[]{'c','o','u','c','o','u'});
						// si on n a pas de permission de write fichier, ceci ne fonctionne pas 
						// ds lors que nous avons un securityManager activ sauf si on grant explicitement
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
				public Object run() throws Exception {
					Thread.sleep(500);
					Facture f=new Facture(v,cname.getName());// getName invoque via le reseau... peut etre penalisant ! On aimerait utiliser  la place un smartproxy
					// l'utilisation de cname qui est un objet Remote n'a pas besoin d'utiliser de socket securis
					cname.facturer(f); // le champ destinataire ne sera pas srialis (voir classe Facture et ses mthodes de de/serialisation) car cname est le bon client: pas la peine de lui redire quel est son nom !
					System.out.println("Nouvelle " + f);
					this.ecrireFichier();
					return val * v;
				}
			}, null);
		} catch (PrivilegedActionException pae){
			if (pae.getException() instanceof RemoteException)
				throw (RemoteException)pae.getException();
		}
		return val;
	}

}
